#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './createsshkeys_base.ui'
**
** Created: Sun Sep 2 03:23:21 2007
**      by: The User Interface Compiler ($Id: qt/main.cpp   3.3.8   edited Jan 11 14:47 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "createsshkeys_base.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qspinbox.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qlabel.h>
#include <kurlrequester.h>
#include <qcheckbox.h>
#include <kpassdlg.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "kurlrequester.h"
#include "klineedit.h"
#include "kpushbutton.h"
#include "kpassdlg.h"

/*
 *  Constructs a CreateSSHKeys_base as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
CreateSSHKeys_base::CreateSSHKeys_base( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "CreateSSHKeys_base" );
    CreateSSHKeys_baseLayout = new QVBoxLayout( this, 11, 6, "CreateSSHKeys_baseLayout"); 

    layout6 = new QHBoxLayout( 0, 0, 6, "layout6"); 

    groupBox3 = new QGroupBox( this, "groupBox3" );
    groupBox3->setColumnLayout(0, Qt::Vertical );
    groupBox3->layout()->setSpacing( 6 );
    groupBox3->layout()->setMargin( 11 );
    groupBox3Layout = new QHBoxLayout( groupBox3->layout() );
    groupBox3Layout->setAlignment( Qt::AlignTop );

    keySize = new QSpinBox( groupBox3, "keySize" );
    keySize->setMaxValue( 8192 );
    keySize->setMinValue( 768 );
    keySize->setLineStep( 512 );
    keySize->setValue( 2048 );
    groupBox3Layout->addWidget( keySize );
    layout6->addWidget( groupBox3 );

    keyTypeGroup = new QButtonGroup( this, "keyTypeGroup" );
    keyTypeGroup->setColumnLayout(0, Qt::Vertical );
    keyTypeGroup->layout()->setSpacing( 6 );
    keyTypeGroup->layout()->setMargin( 11 );
    keyTypeGroupLayout = new QHBoxLayout( keyTypeGroup->layout() );
    keyTypeGroupLayout->setAlignment( Qt::AlignTop );

    keyTypeDSA = new QRadioButton( keyTypeGroup, "keyTypeDSA" );
    keyTypeGroupLayout->addWidget( keyTypeDSA );

    keyTypeRSA = new QRadioButton( keyTypeGroup, "keyTypeRSA" );
    keyTypeRSA->setChecked( TRUE );
    keyTypeGroupLayout->addWidget( keyTypeRSA );
    layout6->addWidget( keyTypeGroup );
    CreateSSHKeys_baseLayout->addLayout( layout6 );

    groupBox4 = new QGroupBox( this, "groupBox4" );
    groupBox4->setColumnLayout(0, Qt::Vertical );
    groupBox4->layout()->setSpacing( 6 );
    groupBox4->layout()->setMargin( 11 );
    groupBox4Layout = new QVBoxLayout( groupBox4->layout() );
    groupBox4Layout->setAlignment( Qt::AlignTop );

    layout26 = new QGridLayout( 0, 1, 1, 0, 6, "layout26"); 

    textPrivateKey = new QLabel( groupBox4, "textPrivateKey" );

    layout26->addWidget( textPrivateKey, 0, 0 );

    keyFile = new KURLRequester( groupBox4, "keyFile" );

    layout26->addWidget( keyFile, 0, 1 );

    textPublicKey = new QLabel( groupBox4, "textPublicKey" );

    layout26->addWidget( textPublicKey, 1, 0 );

    textPublicKeyShow = new QLabel( groupBox4, "textPublicKeyShow" );

    layout26->addWidget( textPublicKeyShow, 1, 1 );
    groupBox4Layout->addLayout( layout26 );
    CreateSSHKeys_baseLayout->addWidget( groupBox4 );

    groupBox5 = new QGroupBox( this, "groupBox5" );
    groupBox5->setColumnLayout(0, Qt::Vertical );
    groupBox5->layout()->setSpacing( 6 );
    groupBox5->layout()->setMargin( 11 );
    groupBox5Layout = new QVBoxLayout( groupBox5->layout() );
    groupBox5Layout->setAlignment( Qt::AlignTop );

    usePassword = new QCheckBox( groupBox5, "usePassword" );
    groupBox5Layout->addWidget( usePassword );

    layout21 = new QGridLayout( 0, 1, 1, 0, 6, "layout21"); 

    keyPasswordAgain = new KPasswordEdit( groupBox5, "keyPasswordAgain" );
    keyPasswordAgain->setEnabled( FALSE );

    layout21->addWidget( keyPasswordAgain, 1, 1 );

    textPasswordAgain = new QLabel( groupBox5, "textPasswordAgain" );

    layout21->addWidget( textPasswordAgain, 1, 0 );

    textPassword = new QLabel( groupBox5, "textPassword" );

    layout21->addWidget( textPassword, 0, 0 );

    keyPassword = new KPasswordEdit( groupBox5, "keyPassword" );
    keyPassword->setEnabled( FALSE );

    layout21->addWidget( keyPassword, 0, 1 );
    groupBox5Layout->addLayout( layout21 );

    textPasswordMatch = new QLabel( groupBox5, "textPasswordMatch" );
    groupBox5Layout->addWidget( textPasswordMatch );
    CreateSSHKeys_baseLayout->addWidget( groupBox5 );

    layout22 = new QHBoxLayout( 0, 0, 6, "layout22"); 

    createButton = new QPushButton( this, "createButton" );
    layout22->addWidget( createButton );
    spacer3 = new QSpacerItem( 461, 41, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout22->addItem( spacer3 );

    exitButton = new QPushButton( this, "exitButton" );
    layout22->addWidget( exitButton );
    CreateSSHKeys_baseLayout->addLayout( layout22 );
    languageChange();
    resize( QSize(589, 367).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( exitButton, SIGNAL( clicked() ), this, SLOT( slotExit() ) );
    connect( createButton, SIGNAL( clicked() ), this, SLOT( slotCreate() ) );
    connect( keyPassword, SIGNAL( textChanged(const QString&) ), this, SLOT( slotPasswordUpdated() ) );
    connect( keyPasswordAgain, SIGNAL( textChanged(const QString&) ), this, SLOT( slotPasswordUpdated() ) );
    connect( keyFile, SIGNAL( textChanged(const QString&) ), this, SLOT( slotKeyFileUpdated() ) );
    connect( usePassword, SIGNAL( toggled(bool) ), this, SLOT( slotUsePassword(bool) ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
CreateSSHKeys_base::~CreateSSHKeys_base()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void CreateSSHKeys_base::languageChange()
{
    setCaption( tr2i18n( "Create SSH Keys" ) );
    groupBox3->setTitle( tr2i18n( "Size in bits" ) );
    keyTypeGroup->setTitle( tr2i18n( "Type" ) );
    keyTypeDSA->setText( tr2i18n( "&DSA" ) );
    keyTypeDSA->setAccel( QKeySequence( tr2i18n( "Alt+D" ) ) );
    keyTypeRSA->setText( tr2i18n( "RS&A" ) );
    keyTypeRSA->setAccel( QKeySequence( tr2i18n( "Alt+A" ) ) );
    groupBox4->setTitle( tr2i18n( "Save as" ) );
    textPrivateKey->setText( tr2i18n( "Private key" ) );
    textPublicKey->setText( tr2i18n( "Public key" ) );
    textPublicKeyShow->setText( QString::null );
    groupBox5->setTitle( tr2i18n( "Password" ) );
    usePassword->setText( tr2i18n( "Protect the private &key with a password" ) );
    usePassword->setAccel( QKeySequence( tr2i18n( "Alt+K" ) ) );
    textPasswordAgain->setText( tr2i18n( "Again" ) );
    textPassword->setText( tr2i18n( "Password" ) );
    textPasswordMatch->setText( QString::null );
    createButton->setText( tr2i18n( "&Create" ) );
    createButton->setAccel( QKeySequence( tr2i18n( "Alt+C" ) ) );
    exitButton->setText( tr2i18n( "E&xit" ) );
    exitButton->setAccel( QKeySequence( tr2i18n( "Alt+X" ) ) );
}

void CreateSSHKeys_base::slotCreate()
{
    qWarning( "CreateSSHKeys_base::slotCreate(): Not implemented yet" );
}

void CreateSSHKeys_base::slotExit()
{
    qWarning( "CreateSSHKeys_base::slotExit(): Not implemented yet" );
}

void CreateSSHKeys_base::slotKeyFileUpdated()
{
    qWarning( "CreateSSHKeys_base::slotKeyFileUpdated(): Not implemented yet" );
}

void CreateSSHKeys_base::slotPasswordUpdated()
{
    qWarning( "CreateSSHKeys_base::slotPasswordUpdated(): Not implemented yet" );
}

void CreateSSHKeys_base::slotUsePassword(bool)
{
    qWarning( "CreateSSHKeys_base::slotUsePassword(bool): Not implemented yet" );
}

#include "createsshkeys_base.moc"
