#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './prefs-base.ui'
**
** Created: Sun Sep 2 03:23:21 2007
**      by: The User Interface Compiler ($Id: qt/main.cpp   3.3.8   edited Jan 11 14:47 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "prefs-base.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qcheckbox.h>
#include <kurlrequester.h>
#include <qlabel.h>
#include <qwidgetstack.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "kurlrequester.h"
#include "klineedit.h"
#include "kpushbutton.h"

/*
 *  Constructs a Prefs_base as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
Prefs_base::Prefs_base( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "Prefs_base" );
    setMinimumSize( QSize( 350, 0 ) );
    Prefs_baseLayout = new QVBoxLayout( this, 11, 6, "Prefs_baseLayout"); 

    groupBox = new QGroupBox( this, "groupBox" );
    groupBox->setColumnLayout(0, Qt::Vertical );
    groupBox->layout()->setSpacing( 6 );
    groupBox->layout()->setMargin( 11 );
    groupBoxLayout = new QVBoxLayout( groupBox->layout() );
    groupBoxLayout->setAlignment( Qt::AlignTop );

    kcfg_useCustomPath = new QCheckBox( groupBox, "kcfg_useCustomPath" );
    groupBoxLayout->addWidget( kcfg_useCustomPath );

    kcfg_sshaskpassPath = new KURLRequester( groupBox, "kcfg_sshaskpassPath" );
    kcfg_sshaskpassPath->setEnabled( FALSE );
    groupBoxLayout->addWidget( kcfg_sshaskpassPath );

    kcfg_useSystray = new QCheckBox( groupBox, "kcfg_useSystray" );
    groupBoxLayout->addWidget( kcfg_useSystray );

    textLabel1 = new QLabel( groupBox, "textLabel1" );
    groupBoxLayout->addWidget( textLabel1 );
    Prefs_baseLayout->addWidget( groupBox );

    startupListStack = new QWidgetStack( this, "startupListStack" );

    WStackPage = new QWidget( startupListStack, "WStackPage" );
    startupListStack->addWidget( WStackPage, 0 );
    Prefs_baseLayout->addWidget( startupListStack );
    languageChange();
    resize( QSize(350, 350).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( kcfg_useCustomPath, SIGNAL( toggled(bool) ), this, SLOT( slotUseCustomPath(bool) ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
Prefs_base::~Prefs_base()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void Prefs_base::languageChange()
{
    setCaption( tr2i18n( "Ksshagent Configuration" ) );
    groupBox->setTitle( tr2i18n( "Options" ) );
    kcfg_useCustomPath->setText( tr2i18n( "&Use custom path to ssh-askpass" ) );
    kcfg_useCustomPath->setAccel( QKeySequence( tr2i18n( "Alt+U" ) ) );
    kcfg_useSystray->setText( tr2i18n( "Use a s&ytsem tray icon" ) );
    kcfg_useSystray->setAccel( QKeySequence( tr2i18n( "Alt+Y" ) ) );
    textLabel1->setText( tr2i18n( "<i>Note: You have to restart the application for this option to have effect.</i>" ) );
}

void Prefs_base::slotUseCustomPath(bool)
{
    qWarning( "Prefs_base::slotUseCustomPath(bool): Not implemented yet" );
}

#include "prefs-base.moc"
